
--
--		
--
--		$project:	Afterlife Crowd Control | TBC Classic
--		$author:	Michael Boyle (a.k.a. Codermik)
--		$contact:	michael.boyle@softrix.co.uk
--		
--		$twitch:	www.twitch.tv/codermik
--
--
--
--		
--				

-- main 
local Afterlife = CreateFrame("Frame")
Afterlife:RegisterEvent("ADDON_LOADED")
Afterlife:RegisterEvent("CHAT_MSG_ADDON")
Afterlife:RegisterEvent("PLAYER_LOGIN")
Afterlife:RegisterEvent("PLAYER_TARGET_CHANGED")
Afterlife:RegisterEvent("PLAYER_FOCUS_CHANGED")
Afterlife:RegisterEvent("PLAYER_REGEN_DISABLED")
Afterlife:RegisterEvent("PLAYER_REGEN_ENABLED")
Afterlife:RegisterEvent("PLAYER_ENTERING_WORLD")
Afterlife:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
Afterlife:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4, arg5) self:OnEvent(event, arg1, arg2, arg3, arg4, arg5) end)
Afterlife:SetScript("OnUpdate", function(self) self:OnUpdate() end)

-- client build info
local buildInfo = select(4, GetBuildInfo())

AFTERLIFE	=	{}
local Version = "r20.10000"
local Date = "05/11/2022"

-- mostly for my use but it will show you the versions
-- of the addon used by yourself and the guild members.
-- set to true if you want this feature.
local AfterlifeVerCheck = false

-- version check
local AfterlifeLocalPrefix = "AfterlifeCC"
local AfterlifeNewSession = true						-- only flag once per session.
local AfterlifeGroupAnnounceVer = true					-- only do it once per session
local AfterlifeRevision = 20

local name = ...

AfterlifeAddonSettings = {

	true,												-- addon active? 
	true,												-- bar anchor visible? 
	false, true,										-- chat / audio announce my crowd controls 
	false, true,										-- chat / audio announce my last 15 seconds
	false, true,										-- chat / audio announce cc breaks
	false, true,										-- chat / audio accounce misses
	false, false,										-- chat / audio announce failures
	true, true,											-- chat / audio announce interrupts
	false,												-- ignore my own cc breaks?

	-- 3d frame (not active in retail version)
	true,												-- show my controlled target as a 3d model.
	255,355,											-- 3d width / height
	700, 0,												-- 3d position
	
	-- batman popup
	true,												-- display batman style popup when cc breaks.	21
	
	-- cc bars
	10, 300, "UP", 20, 300, 6, 20, 1, 14,				-- x, y, dir, height, width, texture, max bars, font (coming soon), font size	22 - 30
	-- diminish returns timer (future)
	10, 390, "UP", 20, 300, 6, 20, 1, 14,				-- x, y, dir, height, width, texture, max bars, font (coming soon), font size	31 - 39
	"Afterlife Crowd Control", "Diminish Returns",		-- group titles		40 / 41

	-- battleground 

	false,												-- do announces when im in a battleground?	42
	true,												-- play killing blow sounds		43
	"Male",												-- male or female quake sounds.	44
	true,												-- other funny sounds		45

	-- other
	true,												-- diminish returns 46

	-- tank extras
	false, false,										-- not used in retail	47 - 48
	false,												-- chat announce taunts, challenging shouts and other useful information.
	false,												-- funny taunt sound.
	false,												-- not used in retail

	-- extra raid leader stuff
	false,												-- raid leader mode - audible warning when a raid mark breaks free [52]
	true, true, true, false, false, false,				-- reserved

}


-- tank abilities to announce.
AfterlifeLastChatFire = 0
AfterlifeTankAbilities = {
	{ 12976, "Last Stand", ">>>> [Last Stand] has been activated, increasing my health by 30% for 20 seconds!", false, false, nil },	-- 12975 is the actual spell, 12976 is the buff applied.. weird huh?
	{ 871, "Shield Wall", ">>>> [Shield Wall] has been used, lasting for 10 seconds!", false, false, nil },
	{ 1161, "Challenging Shout", ">>>> [Challenging Shout] has been used, I will need some extra healing!", false, false, nil },
	-- taunts
	{ 355, "Taunt", ">>>> [Taunt] used on ", true, false, "Interface\\AddOns\\Afterlife\\sounds\\other\\taunt.ogg" },
	{ 6795, "Growl", ">>>> [Growl] used on ", true, false, "Interface\\AddOns\\Afterlife\\sounds\\other\\taunt.ogg" },	
}

-- popup
local AieePopup = CreateFrame("Frame", "WarnFrame", UIParent)
AieePopup:SetFrameStrata("BACKGROUND")
AieePopup:SetScript("OnUpdate", function(self, elapsed) self:OnUpdate(self, elapsed) end)
AieePopup:SetWidth(256)
AieePopup:SetHeight(256)
local AieeTexture = AieePopup:CreateTexture(nil, "BACKGROUND")
AieeTexture:SetAllPoints(AieePopup)
AieePopup.texture = AieeTexture
AieePopup:SetPoint("CENTER",0,100)
AieePopup:Hide()

-- supported spells
AfterlifeSpells = {

	-- Mage
	{118, "Polymorph", 60, nil, true, true, false},									-- polymorph
	{161372, "Polymorph Peacock", 60, nil, true, true, false},						-- polymorph peacock
	{28272, "Polymorph Pig", 60, nil, true, true, false},							-- polymorph pig
	{61780, "Polymorph Turkey", 60, nil, true, true, false},						-- polymorph turkey
	{277792, "Polymorph Bumble Bee", 60, nil, true, true, false},					-- polymorph bumble bee
	{321395, "Polymorph Mawrat", 60, nil, true, true, false},						-- polymorph mawrat
	{161355, "Polymorph Penguin", 60, nil, true, true, false},						-- polymorph penguin
	{126819, "Polymorph Porcupine", 60, nil, true, true, false},					-- polymorph porcupine
	{161353, "Polymorph Polar Bear Cub", 60, nil, true, true, false},				-- polymorph polar bear cub
	{277787, "Polymorph Direhorn", 60, nil, true, true, false},						-- polymorph direhorn
	{28271, "Polymorph Turtle", 60, nil, true, true, false},						-- polymorph turtle
	{161354, "Polymorph Monkey", 60, nil, true, true, false},						-- polymorph monkey
	{61305, "Polymorph Black Cat", 60, nil, true, true, false},						-- polymorph black cat
	{61721, "Polymorph Rabbit", 60, nil, true, true, false},						-- polymorph rabbit
	-- Priest
	{9484, "Shackle Undead", 30, nil, true, true, false},
	{605, "Mind Control", 30, nil, true, false, false},
	-- Druid
	{339, "Entangling Roots Rank 1", 30, nil, true, true, false},
	{343238, "Entangling Roots Rank 2", 30, nil, true, true, false},
	{2637, "Hibernate Rank", 40, nil, true, true, false},
	-- paladin
	{10326, "Turn Evil", 40, 15, true, true, false},	
	{20066, "Repentance", 60, 15, true, true},
	-- warlock
	{5782, "Fear Rank 1", 20, nil, true, true, false},
	{342914, "Fear Rank 2", 20, nil, true, true, false},
	{6358, "Seduction", 30, nil, true, true, false},
	{710, "Banish", 30, nil, false, false, false},
	-- rogue
	{6770, "Sap", 60, nil, true, true, true},
	-- hunter
	{3355, "Freezing Trap Effect", 60, nil, true, true, true},	
	-- monk
	{115078, "Paralysis", 60, 45, true, true, true},	
	{344359, "Paralysis", 60, 30, true, true, true},	

}
-- trap monitoring (for expires etc)
AfterlifeHunterTraps = {
	{187650, "Freezing Trap Effect", 60, 30},
}

-- monitored traps.
AfterlifeMonitoredTrap = {}

-- textures for the bars
AfterlifeTextures = { 

	"Interface\\Addons\\Afterlife\\graphics\\bantobar.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\charcoal.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\otravi.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\perl.tga",
	"Interface\\Addons\\Afterlife\\graphics\\smooth.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\smudge.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\striped.tga", 

}

AfterlifeDiminishGfx = {
	"Interface\\Addons\\Afterlife\\graphics\\drgreen.tga", 
	"Interface\\Addons\\Afterlife\\graphics\\drred.tga", 
}

AfterlifeGenericIcons = {
	"Interface\\Addons\\Afterlife\\graphics\\timer.tga", 
}

-- chat raid icons
local raidicons = {"{rt1} ","{rt2} ","{rt3} ","{rt4} ","{rt5} ", "{rt6} ","{rt7} ","{rt8} ", ""}

-- Raid icon lookup table used for destFlags
local RaidIconLookup = {
	[COMBATLOG_OBJECT_RAIDTARGET1]=1,
	[COMBATLOG_OBJECT_RAIDTARGET2]=2,
	[COMBATLOG_OBJECT_RAIDTARGET3]=3,
	[COMBATLOG_OBJECT_RAIDTARGET4]=4,
	[COMBATLOG_OBJECT_RAIDTARGET5]=5,
	[COMBATLOG_OBJECT_RAIDTARGET6]=6,
	[COMBATLOG_OBJECT_RAIDTARGET7]=7,
	[COMBATLOG_OBJECT_RAIDTARGET8]=8,
}

-- timer bar raid icon path lookup
local raidiconpaths = {
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_1.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_2.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_3.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_4.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_5.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_6.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_7.blp",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_8.blp",
	"",
}

local raidMarkerSounds = {
	"Interface\\AddOns\\Afterlife\\sounds\\other\\star.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\circle.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\diamond.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\triangle.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\moon.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\square.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\cross.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\skull.ogg",
}

local addonsounds = {
	-- 15s warning / 10 second countdown.
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\1sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\2sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\3sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\4sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\5sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\6sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\7sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\8sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\9sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\10sec.ogg",
	"Interface\\AddOns\\Afterlife\\Sounds\\Count\\15sec.ogg",	
	-- other sounds
	"Interface\\AddOns\\Afterlife\\sounds\\other\\interrupt.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\missed.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\ccbreak.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\failed.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\applied.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\renewed.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\alert.ogg",
	"Interface\\AddOns\\Afterlife\\sounds\\other\\notify.ogg",
}

local Monitored = {}
local Diminishes = {}
local CastingGuid = nil
local TargetGUID = nil
local FocusGUID = nil
local PlayerGUID = UnitGUID("player")
local PlayerTrapGUID = nil
local PlayersName = UnitName("player")
local LastCCAppliedGuid = 0
local TargetRaidIcon = nil
local TargetRaidIconNum = nil
local FocusRaidIcon = nil
local FocusRaidIconNum = nil
local OutputDestination = nil
local playerNotInCombat = true

local lasttime = 0
local lastcount = 0

local OutputMessages = {
	">>>> %s was applied to %s (%ss duration).",
	">>>> %s was renewed on %s (%ss duration).",
	">>>> [%s] has failed on %s (%s)!",
	">>>> Interrupted %s's [%s] using %s!",
	">>>> [%s] on %s breaks in %s seconds!",
	">>>> %s has broken free on %s!",
	">>>> %s on %s was broken by %s's %s!",
}

-- hook up with my modified GTB lib.
AfterlifeLib = LibStub:GetLibrary("Codermik-1.0");
AfterlifePrimaryGroup = AfterlifeLib:RegisterGroup(AfterlifeAddonSettings[40], AfterlifeTextures[AfterlifeAddonSettings[27]])
AfterlifeDiminishGroup = AfterlifeLib:RegisterGroup(AfterlifeAddonSettings[41], AfterlifeTextures[AfterlifeAddonSettings[36]])

--
--	Main OnUpdate Event
--
function Afterlife:OnUpdate()
	Afterlife:RemoveExpired()
	Afterlife:RemoveExpiredTrap()
	Afterlife:AnnounceCountdown()
end
 

--
--	Aieee OnUpdate Event
--
local UpdateInterval = .01; 
local ScaleInterval = .1; 
local AieeScale = .01;
local AieePause = 0;
local GraphicPause = 150; 
local TimeSinceLastUpdate = 0;
local ScaleDirection = "up";
local MovingPopup = false; 
function AieePopup:OnUpdate(self, elapsed)
	if(MovingPopup == false) then
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		while(TimeSinceLastUpdate > UpdateInterval) do 
			if(ScaleDirection == "up") then
				AieeScale = AieeScale + ScaleInterval
				WarnFrame:SetScale(AieeScale)
				if(AieeScale >= 1) then
					ScaleDirection = "pause"
				end
			elseif(ScaleDirection == "down") then
				if(AieeScale <= .2) then
					WarnFrame:Hide()
					return
				else
					AieeScale = AieeScale - ScaleInterval
					WarnFrame:SetScale(AieeScale)
				end;
			elseif(ScaleDirection == "pause") then
				AieePause = AieePause + 1
				if(AieePause > GraphicPause) then
					ScaleDirection = "down"
				end;
			end;
			TimeSinceLastUpdate = TimeSinceLastUpdate - UpdateInterval
		end
	end
end

--
--	Initialise Bar Group
--
function initBarGroup()
	-- crowd controls
	AfterlifePrimaryGroup:RegisterOnMove("AfterlifeCCOnBarMove")
	AfterlifePrimaryGroup:SetInvert(false)
	AfterlifePrimaryGroup:SetScale(1.0)
	AfterlifePrimaryGroup:SetMaxBars(AfterlifeAddonSettings[28])
	AfterlifePrimaryGroup:SetHeight(AfterlifeAddonSettings[25])
	AfterlifePrimaryGroup:SetWidth(AfterlifeAddonSettings[26])
	AfterlifePrimaryGroup:SetDisplayGroup("")
	AfterlifePrimaryGroup:SetAnchorVisible(AfterlifeAddonSettings[2])
	AfterlifePrimaryGroup:SetBarGrowth(AfterlifeAddonSettings[24])
	AfterlifePrimaryGroup:SetGroupFontSize(AfterlifeAddonSettings[30])
	AfterlifePrimaryGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", AfterlifeAddonSettings[22], AfterlifeAddonSettings[23])
	-- diminish returns.
	AfterlifeDiminishGroup:RegisterOnMove("AfterlifeDROnBarMove")
	AfterlifeDiminishGroup:SetInvert(false)
	AfterlifeDiminishGroup:SetScale(1.0)
	AfterlifeDiminishGroup:SetMaxBars(AfterlifeAddonSettings[37])
	AfterlifeDiminishGroup:SetHeight(AfterlifeAddonSettings[34])
	AfterlifeDiminishGroup:SetWidth(AfterlifeAddonSettings[35])
	AfterlifeDiminishGroup:SetDisplayGroup("")
	AfterlifeDiminishGroup:SetAnchorVisible(AfterlifeAddonSettings[2])
	AfterlifeDiminishGroup:SetBarGrowth(AfterlifeAddonSettings[33])
	AfterlifeDiminishGroup:SetGroupFontSize(AfterlifeAddonSettings[39])
	AfterlifeDiminishGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", AfterlifeAddonSettings[31], AfterlifeAddonSettings[32])
end
function AfterlifeCCOnBarMove(parent, x, y)
	AfterlifeAddonSettings[22] = x 
	AfterlifeAddonSettings[23] = y 
end
function AfterlifeDROnBarMove(parent, x, y)
	AfterlifeAddonSettings[31] = x 
	AfterlifeAddonSettings[32] = y 
end

--
--	Remove an unwanted buff from the player
--
function Afterlife:CancelMonitoredBuff(buffname, caster, announce)
	local counter = 1
	while UnitBuff("player", counter) do
		local name = UnitBuff("player", counter)
		if string.find(name, buffname) then
			if playerNotInCombat then
				CancelUnitBuff("player", counter)
				if announce then
					if caster then
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..buffname.."|cffffffff cast by |cffFFFF00"..caster.."|cffffffff was automatically removed.")
					else
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..buffname.."|cffffffff was automatically removed.")
					end
					PlaySoundFile(addonsounds[19], "Master")
				end				
			else
				-- we found a nasty buff and i am in combat, need to warn the player
				PlaySoundFile(addonsounds[18], "Master")
				if announce then
					if caster then
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..buffname.."|cffff6060 cast by |cffFFFF00"..caster.."|cffff6060 is active and could not be removed automatically due to combat - remove manually to avoid losing threat!")
					else
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..buffname.."|cffff6060 is active and could not be removed automatically due to combat - remove manually to avoid losing threat!")
					end
				end
			end
			return
		end
		counter = counter + 1
	end
end

--
--	Function to check if I am in a guild.
--
function Afterlife:IsPlayerInGuild()
    return IsInGuild() -- and GetGuildInfo("player")
end

---
--- global event processor
---
function Afterlife:OnEvent(event, arg1, arg2, arg3, arg4, arg5)
	
	if event == "ADDON_LOADED" then
		if not arg1 == name then return end
		Afterlife:UnregisterEvent("ADDON_LOADED")
		AfterlifeUpdateSettings()
		initBarGroup()
		-- settings loaded, display a welcome message.
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffffffff (Build "..Version.." - "..Date..") Loaded! - type |cffFFFF00/afterlife|cffffffff for options, please report any bugs.")
	end

	if event == "PLAYER_LOGIN" then local prefixResult = C_ChatInfo.RegisterAddonMessagePrefix(AfterlifeLocalPrefix) end
	if event == "PLAYER_ENTERING_WORLD" then
		if Afterlife:IsPlayerInGuild() then C_ChatInfo.SendAddonMessage(AfterlifeLocalPrefix, AfterlifeRevision, "GUILD") end
	end

	if event == "CHAT_MSG_ADDON" then
		if arg1 == AfterlifeLocalPrefix then
			-- this is a message from this addon.
			if arg2 then
				arg2 = tonumber(arg2)
				if arg2 > AfterlifeRevision and AfterlifeNewSession then
					-- detected a newer version of the addon, lets let the player know.
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control : |cffffffff There is a new version available, you are using version |cffFFFF00r"..AfterlifeRevision.."|cffffffff and version |cffFFFF00r"..arg2.."|cffffffff is available for download which contains improvements and bug fixes.")
					AfterlifeNewSession = false
				end 
				-- guild version check - for my use testing the addon with the guild testers. --
				if arg5 and arg5 ~= PlayersName and AfterlifeVerCheck then 
					PlaySoundFile(addonsounds[19], "Master")
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control : |cffFFFF00"..arg5.."|cffffffff has |cffFFFF00r"..arg2.."|cffffffff installed.") 
				end
			end
		end
	end

	if event == "PLAYER_REGEN_DISABLED" then playerNotInCombat = false end
	if event == "PLAYER_REGEN_ENABLED" then 
		playerNotInCombat = true 
	end

	if event == "PLAYER_TARGET_CHANGED" then
		TargetGUID = UnitGUID("target")
	end

	if event == "PLAYER_FOCUS_CHANGED" then
		FocusGUID = UnitGUID("target")
	end

	if event == "COMBAT_LOG_EVENT_UNFILTERED" and AfterlifeAddonSettings[1] then		
		local _, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19 = CombatLogGetCurrentEventInfo()

		if arg2 == "SPELL_CAST_SUCCESS" then
			if Afterlife:InterestedSpell(arg12) then
				if arg4 == PlayerGUID then
					mobGuid, _, _, _, _, _, spellName, spellBreakable, _, _, _, _, _ = Afterlife:ReadMonitoredMob(arg8)
					local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
					if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
					if mobGuid and spellBreakable then
						Afterlife:RemoveMonitoredMob(arg8)
						lasttime = 0
						lastcount = 0
						AfterlifePrimaryGroup:UnregisterBar(arg4)
						spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
						Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)
						LastCCAppliedGuid = arg8
					end
				else
					mobGuid, mobName, _, casterGuid, casterName, spellId, spellName, spellBreakable, _, _, _, _, _ = Afterlife:ReadMonitoredMob(arg8)
					if mobGuid and casterGuid == PlayerGUID and spellName == arg13 then
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..mobName.."|cffffffff (your original target) had |cffFFFF00"..spellName.."|cffffffff applied by |cffFFFF00"..arg5.."|cffffffff!")
						Afterlife:RemoveMonitoredMob(arg8)
						local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
						if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
						spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
						Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)
						PlaySoundFile(addonsounds[17], "Master") 
					end
				end

			else
				-- extra attention needs to be given on traps, not perfect but i will work out a better solution.
				if arg4 == PlayerGUID then
					-- this was something i did, have i just dropped a trap?
					spellId, spellName, spellDuration, spellCooldown = Afterlife:GetTrapInformaion(arg12)
					if spellName then
						-- set a expire timer for trap
						Afterlife:AddDroppedTrap(arg12, spellDuration, spellCooldown, arg4, GetTime())	
						-- store the target i had when i lay down the trap
						PlayerTrapGUID = TargetGUID
					end
				end
				-- was this a ability I want to shout about?
				if AfterlifeAddonSettings[49] then
					if arg4 == PlayerGUID then
						spellId, spellName, chatMessage, showTarget, eventCheck, soundPath = Afterlife:ReadMonitoredTankAbilities(arg12)
						if spellName and eventCheck == true then
							-- its something I am interested in.
							Afterlife:ChatDestination()	
							-- some abilities apply a debuff on multiple mobs such as commanding shout, this would be spammy
							-- as hell therefore the addon will ignore anything within a 1.5 second period, this should be more
							-- than enough to suppress multiple messages such as this.
							if (GetTime() - AfterlifeLastChatFire) > 1.5 or AfterlifeLastChatFire == 0 then
								AfterlifeLastChatFire = GetTime()	-- record last fire.
								if OutputDestination then 
									if showTarget then
										targetsName = UnitName("target")
										if targetsName then
											-- read any raid icon on target.
											targetRaidIcon = GetRaidTargetIndex("target")
											if targetRaidIcon then targetRaidIcon = raidicons[targetRaidIcon] else targetRaidIcon = raidicons[9] end
											SendChatMessage(chatMessage..targetRaidIcon..targetsName..".", OutputDestination, NIL)
										else
											SendChatMessage(chatMessage, OutputDestination, NIL) 
										end
									else
										SendChatMessage(chatMessage, OutputDestination, NIL) 
									end
								end
								if AfterlifeAddonSettings[50] and soundPath then PlaySoundFile(soundPath, "Master") end
							end
						end
					end
				end
			end

		elseif arg2 == "SPELL_AURA_APPLIED" then
			if Afterlife:InterestedSpell(arg12) then
				-- get the raid icon (if any)
				local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
				if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
				if arg4 == PlayerGUID then
					-- this was my cast
					lasttime = 0
					lastcount = 0
					-- remove any generic running timers.
					AfterlifePrimaryGroup:UnregisterBar(arg4)
					spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
					Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)
					LastCCAppliedGuid = arg8
				else
					-- this was another player cc
					spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
					Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)					
				end
			else				
				if AfterlifeAddonSettings[49] then
					-- was it a tank ability I want to shout about?
					if arg4 == PlayerGUID then
						spellId, spellName, chatMessage, showTarget, eventCheck, soundPath = Afterlife:ReadMonitoredTankAbilities(arg12)
						if spellName and eventCheck ~= true then
							Afterlife:ChatDestination()								
							-- some abilities apply a debuff on multiple mobs such as commanding shout, this would be spammy
							-- as hell therefore the addon will ignore anything within a 1.5 second period, this should be more
							-- than enough to suppress multiple messages such as this.
							if (GetTime() - AfterlifeLastChatFire) > 1.5 or AfterlifeLastChatFire == 0 then
								AfterlifeLastChatFire = GetTime()	-- record last fire.
								if OutputDestination then 
									if showTarget then
										targetsName = UnitName("target")
										if targetsName then
											-- read any raid icon on target.
											targetRaidIcon = GetRaidTargetIndex("target")
											if targetRaidIcon then targetRaidIcon = raidicons[targetRaidIcon] else targetRaidIcon = raidicons[9] end
											SendChatMessage(chatMessage..targetRaidIcon..targetsName..".", OutputDestination, NIL)
										else
											SendChatMessage(chatMessage, OutputDestination, NIL) 
										end
									else
										SendChatMessage(chatMessage, OutputDestination, NIL) 
									end
								end
								if AfterlifeAddonSettings[50] and soundPath then PlaySoundFile(soundPath, "Master") end
							end
						end
					end
				end
			end

		elseif arg2 == "SPELL_AURA_REFRESH" then
			if Afterlife:InterestedSpell(arg12) then
				-- get raid icon (if any)
				local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
				if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
				if arg4 == PlayerGUID then
					-- this was my cast
					lasttime = 0
					lastcount = 0
					spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
					Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)
					LastCCAppliedGuid = arg8
				else
					spellId, spellName, spellDuration, spellCooldown, diminishReturns, Isbreakable, isInstant, icon = Afterlife:GetSpellDetails(arg12, arg4, arg8)
					Afterlife:AddMonitored(arg8, arg9, TargetRaidIcon, arg4, Afterlife:StripServer(arg5), arg12, arg13, Isbreakable, GetTime(), spellDuration, spellCooldown, icon, TargetRaidIconNum)					
				end
			end

		elseif arg2 == "SPELL_AURA_REMOVED" or arg2 == "SPELL_AURA_DISPELLED" then
			if Afterlife:InterestedSpell(arg12) then
				Afterlife:DiminishReturnTimer(arg8)
				Afterlife:RemoveBroken(arg8, arg9, arg4, arg5)	
			end		

		elseif arg2 == "SPELL_CAST_FAILED" then
			if Afterlife:InterestedSpell(arg12) then
				if arg4 == PlayerGUID then CastingGuid = nil end
				if arg4 == PlayerGUID and AfterlifeAddonSettings[12] then 
					PlaySoundFile(addonsounds[15], "Master")
				end
			end

		elseif arg2 == "SPELL_MISSED" then
			if Afterlife:InterestedSpell(arg12) and arg4 == PlayerGUID then
				local TargetRaidIcon = RaidIconLookup[bit.band(arg11, COMBATLOG_OBJECT_RAIDTARGET_MASK)]
				if TargetRaidIcon then TargetRaidIconNum = TargetRaidIcon TargetRaidIcon = raidicons[TargetRaidIcon] else TargetRaidIcon = raidicons[9] TargetRaidIconNum = 0 end
				Afterlife:ChatDestination()	
				msg = string.format(OutputMessages[3], arg13, TargetRaidIcon..arg9, arg15)
				if OutputDestination  and AfterlifeAddonSettings[9] then SendChatMessage(msg, OutputDestination, NIL) 
				else DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..arg13.."|cffffffff has failed on "..arg9.." ("..arg15..").") end
				if AfterlifeAddonSettings[10] then PlaySoundFile(addonsounds[13], "Master") end
			end

		elseif arg2 == "SPELL_AURA_BROKEN_SPELL" or arg2 == "SPELL_AURA_BROKEN" then
			if Afterlife:InterestedSpell(arg12) then
				Afterlife:DiminishReturnTimer(arg8)
				if arg5 then Afterlife:RemovePlayerBroken(arg8, arg9, arg4, arg5, arg16) end
			end		

		elseif arg2 == "PARTY_KILL" or arg2 == "UNIT_DIED" then
			Afterlife:RemoveMonitoredMob(arg8)
			Afterlife:RemoveDiminishReturn(arg8)

		elseif arg2 == "SPELL_INTERRUPT" then 
			if arg4 == PlayerGUID then
				CastingGuid = nil
				if AfterlifeAddonSettings[14] then PlaySoundFile(addonsounds[12], "Master") end
				if AfterlifeAddonSettings[13] then
					Afterlife:ChatDestination()	
					targetRaidIcon = GetRaidTargetIndex("target")
					if targetRaidIcon then targetRaidIcon = raidicons[targetRaidIcon] else targetRaidIcon = raidicons[9] end
					msg = string.format(OutputMessages[4], targetRaidIcon..arg9, arg16, arg13)
					if OutputDestination then SendChatMessage(msg, OutputDestination, NIL) end
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..arg9.."'s |cffffffff"..arg16.."|cffFFFF00 was INTERRUPTED!")
				end
			end				
		end		
	end			
end

--
--	Do Aieee popup
--
function Afterlife:DoAieeePopup()
	TimeSinceLastUpdate = 0
	AieeScale = .01
	ScaleDirection = "up"
	AieePause = 0
	AieeTexture:SetTexture("Interface\\AddOns\\Afterlife\\graphics\\aiee.tga")
	WarnFrame:Show()
	WarnFrame:SetScale(AieeScale)
end

--
--	Strip the server name from a player (for cross realm instances and battlegrounds - not needed in classic)
--
function Afterlife:StripServer(name) 
	name = string.match(name, "[^-]*")
	return(name)
end

--
--	Is this target a player?
--
function Afterlife:IsUnitPlayer(guid) 
	local type = strsub(guid, 1, 8)  
	if(type == "Creature") then return false end
	return true;
end

--
--	Determine Chat Destination
--
function Afterlife:ChatDestination()
	local playerInstance, instanceType = IsInInstance()
	if instanceType == "pvp" then 
		if AfterlifeAddonSettings[42] then OutputDestination = "BATTLEGROUND" else OutputDestination = nil end
	else
		numPlayers = GetNumGroupMembers();
		if numPlayers > 1 and numPlayers < 6 then OutputDestination = "PARTY"
		elseif numPlayers >= 6 then	OutputDestination = "RAID"
		else OutputDestination = nil end
	end
end

--
--	Read monitored buffs.
--
function Afterlife:ReadMonitoredTankAbilities(spellId)
	for count,value in ipairs(AfterlifeTankAbilities) do  
		if value[1] == spellId then 
			return value[1], value[2], value[3], value[4], value[5], value[6]
		end
	end
	return false
end

--
--	Clear Expired Diminish Returns
--
function Afterlife:DeleteExpiredDiminishReturn()
	for count,value in ipairs(Diminishes) do 
		if(value[1]) then
			local fireTime = value[3]
			local timeNow = GetTime()
			local totaDur = timeNow - fireTime
			if(totaDur > 18) then
				tremove(Diminishes, count)
			end
		end
	end
end

--
--	Add/Update Diminish Return
--
function Afterlife:UpdateDiminishReturn(mobGuid, mobName, spellDuration, spellIcon)
	Afterlife:DeleteExpiredDiminishReturn()
	for count,value in ipairs(Diminishes) do 
		if(value[1] == mobGuid) then 
			local lastDur = value[4]
			lastDur = lastDur / 2 
			value[4] = lastDur
			return lastDur
		end
	end
	tinsert(Diminishes, {mobGuid, mobName, GetTime(), spellDuration, spellIcon})
	return spellDuration
end

--
--	Remove Diminish Return
--
function Afterlife:RemoveDiminishReturn(mobGuid)
	for count,value in ipairs(Diminishes) do 
		if(value[1]==mobGuid) then
			AfterlifeDiminishGroup:UnregisterBar(mobGuid);
			tremove(Diminishes, count)
		end
	end
end

--
--	Diminish Return Timer
--
function Afterlife:DiminishReturnTimer(mobGuid)
	for count,value in ipairs(Diminishes) do 
		if(value[1]==mobGuid) then
			value[3] = GetTime()
 			AfterlifeDiminishGroup:SetInvert(false)
			AfterlifeDiminishGroup:RegisterBar(value[1], value[2].." (DR)", 18, 18, value[5], AfterlifeDiminishGfx[2])
		end
	end
end

--
--	Diminish Return Check
--
function Afterlife:DiminishReturnCheck(mobGuid)
	for count,value in ipairs(Diminishes) do 
		if(value[1]==mobGuid) then
			return true
		end
	end
	return false
end

-- 
--	Add Monitored Crowd Control.
--
function Afterlife:AddMonitored(mobGuid, mobName, mobRaidIcon, casterGuid, casterName, spellId, spellName, spellBreakable, fireTime, spellDuration, spellCooldown, spellIcon, iconNumber)
	isRenewal = false	
	Afterlife:RemoveExpired()
	if Afterlife:RemoveMonitored(mobGuid, spellId, casterGuid) then isRenewal = true end
	-- take care if this is a player!
	if Afterlife:IsUnitPlayer(mobGuid) then 
		spellDuration = Afterlife:UpdateDiminishReturn(mobGuid, mobName, spellDuration, spellIcon)
	end
	tinsert(Monitored, {mobGuid, mobName, mobRaidIcon, casterGuid, casterName, spellId, spellName, spellBreakable, fireTime, spellDuration, spellCooldown, mobGuid..casterName, spellIcon, iconNumber})
	AfterlifePrimaryGroup:RegisterBar(mobGuid..casterName, spellName.." ("..casterName..")", spellDuration, spellDuration, spellIcon, raidiconpaths[iconNumber])
	Afterlife:ChatDestination()
	if isRenewal then msg = string.format(OutputMessages[2], spellName, mobRaidIcon..mobName, spellDuration)
	else msg = string.format(OutputMessages[1], spellName, mobRaidIcon..mobName, spellDuration) end
	if casterGuid == PlayerGUID then
		if OutputDestination and AfterlifeAddonSettings[3] then 
			SendChatMessage(msg, OutputDestination, NIL) 
		else
			if isRenewal then DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..spellName.." ("..spellDuration.."s duration)|cffffffff was renewed on "..mobName..".")	
			else DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..spellName.." ("..spellDuration.."s duration)|cffffffff was applied to "..mobName..".") end
		end
		if AfterlifeAddonSettings[4] and isRenewal then 
			PlaySoundFile(addonsounds[17], "Master") 
		elseif AfterlifeAddonSettings[4] then
			PlaySoundFile(addonsounds[16], "Master")
		end 
	end
end

-- 
--	Read Monitored Crowd Control (by mob guid).
--
function Afterlife:ReadMonitoredMob(mobGuid)
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid then 
			return value[1], value[2], value[3], value[4], value[5], value[6], value[7], value[8], value[9], value[10], value[11]
		end
	end
	return false
end

-- 
--	Read Monitored Crowd Control (by caster guid).
--
function Afterlife:ReadMonitoredCaster(casterGuid)
	for count,value in ipairs(Monitored) do  
		if value[4] == casterGuid then 
			return value[1], value[2], value[3], value[4], value[5], value[6], value[7], value[8], value[9], value[10], value[11]
		end
	end
	return false
end

--
--	Remove entry
--
function Afterlife:RemoveMonitored(mobGuid, spellId, casterGuid)	
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid and value[6] == spellId and value[4] == casterGuid then 
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			tremove(Monitored, count)
			return true
		end
	end
	return false
end

--
--	Remove expired entry
--
function Afterlife:RemoveExpired()
	for count,value in ipairs(Monitored) do 
		local castTime = value[9]
		local timeNow = GetTime()
		local totaDur = (timeNow - castTime)-1
		if totaDur > value[10] then
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			tremove(Monitored, count)
		end
	end
end

--
--	Remove dead controlled mob
--
function Afterlife:RemoveMonitoredMob(mobGuid)
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid then 
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			tremove(Monitored, count)
			return true
		end
	end
	return false
end

--
--	Remove broke crowd control (by player)
--
function Afterlife:RemovePlayerBroken(mobGuid, mobName, casterGuid, casterName, castSpell)
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid and value[8] == true then 
			Afterlife:ChatDestination()
			if castSpell then 
				msg = string.format(OutputMessages[7], value[7], value[3]..value[2], casterName, castSpell)
			else
				msg = string.format(OutputMessages[6], value[7], value[3]..value[2])
			end			
			-- I only want to announce if the original cast was mine.
			if value[4] == PlayerGUID then
				CastingGuid = nil
				if OutputDestination and AfterlifeAddonSettings[7] then 
					if casterName == PlayersName then
						-- am i ignoring my own breaks?
						if not AfterlifeAddonSettings[15] then SendChatMessage(msg, OutputDestination, NIL)  end
					else
						-- this wasnt broken by me, just announce.
						SendChatMessage(msg, OutputDestination, NIL) 
					end
				else
					if castSpell then 
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff on |cffFFFF00"..value[2].."|cffffffff was broken by |cffFFFF00"..casterName.."'s|cffffffff "..castSpell.."!")
					else
						DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff has broken on |cffFFFF00"..value[2].."|cffffffff!")
					end
				end
			else
				-- this was not something I cast, am i in raid leader mode and want the marks announced?
				if AfterlifeAddonSettings[52] then
					if value[14] > 0 then 
						-- raidMarkerSounds
						PlaySoundFile(raidMarkerSounds[value[14]], "Master")
					end
				end
			end
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			-- was the caster me breaking my own cc target
			if casterGuid == PlayerGUID and value[4] == PlayerGUID and not AfterlifeAddonSettings[15] then
				-- this was my cast, a cast that i personally broke and i still want to announce.
				if AfterlifeAddonSettings[21] then Afterlife:DoAieeePopup() end
				if AfterlifeAddonSettings[8] then PlaySoundFile(addonsounds[14], "Master") end
			elseif casterGUID ~= PlayerGUID and value[4] == PlayerGUID then
				-- the caster breaking wasnt me but the original cc target was mine!
				if AfterlifeAddonSettings[21] then Afterlife:DoAieeePopup() end
				if AfterlifeAddonSettings[8] then PlaySoundFile(addonsounds[14], "Master") end 
			end
			tremove(Monitored, count)
			return true
		end
	end
	return false
end

--
-- Remove broken crowd control (normal broken)
-- 
function Afterlife:RemoveBroken(mobGuid, mobName, casterGuid, casterName)
	for count,value in ipairs(Monitored) do  
		if value[1] == mobGuid then 
			Afterlife:ChatDestination()
			msg = string.format(OutputMessages[6], value[7], value[3]..value[2])
			if value[4] == PlayerGUID then
				CastingGuid = nil
				if OutputDestination and AfterlifeAddonSettings[7] then 
					SendChatMessage(msg, OutputDestination, NIL) 
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff has broken on |cffFFFF00"..value[2].."|cffffffff!")
				end
			else
				-- this was not something I cast, am i in raid leader mode and want the marks announced?
				if AfterlifeAddonSettings[52] then
					if value[14] > 0 then 
						-- raidMarkerSounds						
						PlaySoundFile(raidMarkerSounds[value[14]], "Master")
					end
				end
			end
			AfterlifePrimaryGroup:UnregisterBar(value[12])
			if casterGuid == PlayerGUID then
				-- this is my cast and ive not turned off my personal announces.
				if AfterlifeAddonSettings[21] then Afterlife:DoAieeePopup() end
				if AfterlifeAddonSettings[8] then PlaySoundFile(addonsounds[14], "Master") end
			end
			tremove(Monitored, count)
			return true
		end
	end
	return false
end

--
--	quick function to check this is a spell im interested in
--
function Afterlife:InterestedSpell(spellid) 
	for count,value in ipairs(AfterlifeSpells) do 
		if value[1]==spellid then return true end
	end
	return false
end

--
--	get trap information, returns duration and cooldown info
--
function Afterlife:GetTrapInformaion(spellId)
	for count,value in ipairs(AfterlifeHunterTraps) do 
		if value[1]==spellId then 
			return value[1], value[2], value[3], value[4]	-- spellId, spellName, spellDuration, spellCooldown
		end
	end
	return nil
end

--
--	is there a trap already down belonging to me?
--
function Afterlife:CheckTrapDown(spellId, casterGuid)
	for count,value in ipairs(AfterlifeMonitoredTrap) do 
		if value[1]==spellId and value[4] == casterGuid then 
			tremove(AfterlifeMonitoredTrap, count)
		end
	end
end

--
--	Remove expired entry
--
function Afterlife:RemoveExpiredTrap()
	for count,value in ipairs(AfterlifeMonitoredTrap) do 
		local castTime = value[5]
		local timeNow = GetTime()
		local totaDur = (timeNow - castTime) - 1
		if totaDur > value[2] then 
			tremove(AfterlifeMonitoredTrap, count)
		end
	end
end

--
--	Add Monitored Trap Timer (trap on floor)
--
function Afterlife:AddDroppedTrap(spellId, spellDuration, spellCooldown, casterGuid, fireTime)
	Afterlife:CheckTrapDown(spellId, casterGuid)
	tinsert(AfterlifeMonitoredTrap, {spellId, spellDuration, spellCooldown, casterGuid, fireTime})	
	-- since ive put down a trap, lets give the player a handy trap timer.
	local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(spellId)
	AfterlifePrimaryGroup:RegisterBar(casterGuid, "Freezing Trap", spellDuration, spellDuration, AfterlifeGenericIcons[1], icon)
end

--
--	return details about an interested cc spell. if the target is a player
--	and the spell duration is 10 or above it will default to max 10
--
function Afterlife:GetSpellDetails(spellid, casterguid, mobguid)
	for count,value in ipairs(AfterlifeSpells) do 	
		local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(spellid)
		-- here we need to check if the target was a player to support diminish returns.
		if value[1]==spellid then 
			if Afterlife:IsUnitPlayer(mobguid) and value[3] > 9 then
				-- target is a player, diminish returns come into play here, players
				-- can only be crowd controlled for 10 seconds then halfing each time
				-- to the point of becoming immune from cc for 18 seconds.
				return value[1], value[2], 10, value[4], value[5], value[6], value[7], icon 
			else
				return value[1], value[2], value[3], value[4], value[5], value[6], value[7], icon 
			end
		end
	end
	return nil
end

--
--	Announce last remaining seconds
--
function Afterlife:AnnounceCountdown()
	for count,value in ipairs(Monitored) do 
		if PlayerGUID == value[4] then
			local timeleft = format("%2.1f",tonumber(value[10])-(GetTime()-tonumber(value[9])))
			local counttime = format("%d", timeleft)
			if tonumber(counttime) >= 0 and tonumber(counttime) <= 9 and not(lastcount == counttime) then
				lastcount = counttime
				if AfterlifeAddonSettings[6] then 
					PlaySoundFile(addonsounds[tonumber(counttime)+1], "Master")
				end
			end	
			if tonumber(timeleft) == 15.0 and not(lasttime == timeleft) then
				lasttime = timeleft
				Afterlife:ChatDestination()
				msg = string.format(OutputMessages[5], value[7], value[3]..value[2], counttime)
				if OutputDestination and AfterlifeAddonSettings[5] then 
					SendChatMessage(msg, OutputDestination, NIL) 
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff on |cffFFFF00"..value[2].."|cffffffff breaks in 15 seconds!")				
				end
				if AfterlifeAddonSettings[6] then PlaySoundFile(addonsounds[11], "Master") end
			elseif tonumber(timeleft) == 10.0 and not(lasttime == timeleft) then
				lasttime = timeleft
				Afterlife:ChatDestination()
				msg = string.format(OutputMessages[5], value[7], value[3]..value[2], counttime)
				if OutputDestination and AfterlifeAddonSettings[5] then 
					SendChatMessage(msg, OutputDestination, NIL) 
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff on |cffFFFF00"..value[2].."|cffffffff breaks in 10 seconds!")				
				end
			elseif tonumber(timeleft) == 5.0 and not(lasttime == timeleft) then
				lasttime = timeleft
				Afterlife:ChatDestination()
				msg = string.format(OutputMessages[5], value[7], value[3]..value[2], counttime)
				if OutputDestination and AfterlifeAddonSettings[5] then 
					SendChatMessage(msg, OutputDestination, NIL) 
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00"..value[7].."|cffffffff on |cffFFFF00"..value[2].."|cffffffff breaks in 5 seconds!")				
				end
			end					
		end
	end
end

---
--- global slash command processor
---
function ProcessCommandline(args)
	if args == "reset" then
		-- reset bar positions
		AfterlifeAddonSettings[22] = 10 
		AfterlifeAddonSettings[23] = 300
		AfterlifeAddonSettings[2] = true
		AfterlifeAddonSettings[31] = 10 
		AfterlifeAddonSettings[32] = 380
		AfterlifePrimaryGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", AfterlifeAddonSettings[22], AfterlifeAddonSettings[23])
		AfterlifeDiminishGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", AfterlifeAddonSettings[31], AfterlifeAddonSettings[32])
		AfterlifePrimaryGroup:SetAnchorVisible(AfterlifeAddonSettings[2])
		if AfterlifeAddonSettings[46] then AfterlifeDiminishGroup:SetAnchorVisible(AfterlifeAddonSettings[2]) end
		options:Show()
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffFFFF00Bar groups have been reset to their default positions.")
	else
		AfterlifeOptions:Show()
	end
end


SLASH_AFTERLIFE1				= "/afterlife"
SlashCmdList["AFTERLIFE"] 		= ProcessCommandline



