
--
--		
--
--		$project:	Afterlife Crowd Control | TBC Classic
--		$version:	r25.20504
--		$date:		22/03/2022 R25
--
--		$author:	Michael Boyle (a.k.a. Codermik)
--		$contact:	michael.boyle@softrix.co.uk
--		
--		$twitch:	www.twitch.tv/codermik
--
--
--
--		
--	

local AfterlifePlayerIcon = "Interface\\Addons\\Afterlife\\graphics\\neplayer.tga"
--
--	Close Options Screen
--
function AfterlifeCloseOptions_OnClick()
	AfterlifeOptions:Hide()
end

--
--	Simple little function to update settings ui with current saved settings.
--
function AfterlifeUpdateSettings()
	-- checkboxes
	if AfterlifeAddonSettings[1] then AfterlifeEnableAddon:SetChecked(true) end						-- addon status
	if AfterlifeAddonSettings[3] then ChatAnnounceCrowdControls:SetChecked(true) end				-- announce cc in chat
	if AfterlifeAddonSettings[4] then AudioAnnounceCrowdControls:SetChecked(true) end				-- announce cc with audio
	if AfterlifeAddonSettings[5] then ChatAnnounce15sLeft:SetChecked(true) end						-- announce 15s in chat
	if AfterlifeAddonSettings[6] then AudioAnnounce15sLeft:SetChecked(true) end						-- announce 15s with audio
	if AfterlifeAddonSettings[7] then ChatAnnounceCrowdBreaks:SetChecked(true) end					-- announce breaks in chat
	if AfterlifeAddonSettings[8] then AudioAnnounceCrowdBreaks:SetChecked(true) end					-- announce breaks with audio
	if AfterlifeAddonSettings[9] then ChatAnnounceSpellMisses:SetChecked(true) end					-- announce misses in chat
	if AfterlifeAddonSettings[10] then AudioAnnounceSpellMisses:SetChecked(true) end				-- announce misses with audio
	if AfterlifeAddonSettings[11] then ChatAnnounceSpellFailure:SetChecked(true) end				-- announce failures in chat
	if AfterlifeAddonSettings[12] then AudioAnnounceSpellFailure:SetChecked(true) end				-- announce failures with audio
	if AfterlifeAddonSettings[13] then ChatAnnounceInterrupts:SetChecked(true) end					-- announce interrupts in chat
	if AfterlifeAddonSettings[14] then AudioAnnounceInterrupts:SetChecked(true) end					-- announce interrupts with audio
	if AfterlifeAddonSettings[15] then IgnorePersonalBreaks:SetChecked(true) end					-- ignore my own cc breaks?
	if AfterlifeAddonSettings[21] then DisplayBatmanPopup:SetChecked(true) end						-- show Aieee frame
	if AfterlifeAddonSettings[42] then AnnounceInBG:SetChecked(true) end							-- announce in battlegrounds?

	if AfterlifeAddonSettings[49] then ChatAnnounceTankAbilities:SetChecked(true) end				-- announce tank abilities
	if AfterlifeAddonSettings[50] then AudioAnnounceTaunt:SetChecked(true) end						-- audio announce tank taunt
	if AfterlifeAddonSettings[52] then AfterlifeAnnounceRaidMarkers:SetChecked(true) end			-- announce raid markers

	-- bars
	BarSliderHeight:SetValue(AfterlifeAddonSettings[25])
	BarSliderWidth:SetValue(AfterlifeAddonSettings[26])
	BarSliderFont:SetValue(AfterlifeAddonSettings[30])
	BarSliderTexture:SetValue(AfterlifeAddonSettings[27])
	AfterlifeGroupTexture:SetTexture(AfterlifeTextures[AfterlifeAddonSettings[27]])

end


--
--	Enable / Disable Addon
--
function AfterlifeEnableAddon_OnClick()
	if AfterlifeEnableAddon:GetChecked() then AfterlifeAddonSettings[1] = true else AfterlifeAddonSettings[1] = false end
	if AfterlifeAddonSettings[1] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 is turned OFF!") 
	end
end

--
--	Bar Anchor Toggle
--
function ToggleBarTitle_OnClick()
	if AfterlifeAddonSettings[2] then 
		AfterlifeAddonSettings[2] = false 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Bar group anchors are now hidden.") 
	else 
		AfterlifeAddonSettings[2] = true 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Bar group anchors are now visible - hold ALT and drag the title bars to a preferred location.") 
	end	
	AfterlifePrimaryGroup:SetAnchorVisible(AfterlifeAddonSettings[2])
	if AfterlifeAddonSettings[44] then AfterlifeDiminishGroup:SetAnchorVisible(AfterlifeAddonSettings[2]) end
end

--
--	Toggle Test Bars
--
function TestBarsButton_OnClick()
	AfterlifePrimaryGroup:RegisterBar("TestBar1", "Test Timer 1", 50, 50, AfterlifePlayerIcon, "Interface\\TargetingFrame\\UI-RaidTargetingIcon_1.blp")	
	AfterlifePrimaryGroup:RegisterBar("TestBar2", "Test Timer 2", 40, 40, AfterlifePlayerIcon, "Interface\\TargetingFrame\\UI-RaidTargetingIcon_6.blp")	
	AfterlifePrimaryGroup:RegisterBar("TestBar3", "Test Timer 3", 25, 25, AfterlifePlayerIcon, "Interface\\TargetingFrame\\UI-RaidTargetingIcon_3.blp")	
	AfterlifePrimaryGroup:RegisterBar("TestBar4", "Test Timer 4", 15, 15, AfterlifePlayerIcon, "Interface\\TargetingFrame\\UI-RaidTargetingIcon_2.blp")	
	if AfterlifeAddonSettings[44] then AfterlifeDiminishGroup:RegisterBar("TestDRBar1", "Test DR Timer (Castanova)", 18, 18, AfterlifePlayerIcon, AfterlifeDiminishGfx[2]) end
end

--
--	Chat / Audio Announce Crowd Controls
--
function ChatAnnounceCrowdControls_OnClick()
	if ChatAnnounceCrowdControls:GetChecked() then AfterlifeAddonSettings[3] = true else AfterlifeAddonSettings[3] = false end
	if AfterlifeAddonSettings[3] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce for your crowd controls is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce for your crowd controls is now switched OFF!") 
	end	
end

function AudioAnnounceCrowdControls_OnClick()
	if AudioAnnounceCrowdControls:GetChecked() then AfterlifeAddonSettings[4] = true else AfterlifeAddonSettings[4] = false end
	if AfterlifeAddonSettings[4] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when you control a target is switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when you control a target is switched OFF!") 
	end
end

--
--	Chat/Audio Announce last 15 seconds
--
function ChatAnnounce15sLeft_OnClick()
	if ChatAnnounce15sLeft:GetChecked() then AfterlifeAddonSettings[5] = true else AfterlifeAddonSettings[5] = false end
	if AfterlifeAddonSettings[5] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce your last 15 seconds on controlled targets is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce your last 15 seconds on controlled targets is now switched OFF!") 
	end	
end

function AudioAnnounce15sLeft_OnClick()
	if AudioAnnounce15sLeft:GetChecked() then AfterlifeAddonSettings[6] = true else AfterlifeAddonSettings[6] = false end
	if AfterlifeAddonSettings[6] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound on your last 15 seconds of a controlled target is switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound on your last 15 seconds of a controlled target is switched OFF!") 
	end
end

--
--	Chat/Audio Announce Controlled Breaks.
--
function ChatAnnounceCrowdBreaks_OnClick()
	if ChatAnnounceCrowdBreaks:GetChecked() then AfterlifeAddonSettings[7] = true else AfterlifeAddonSettings[7] = false end
	if AfterlifeAddonSettings[7] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when your controlled target is broken is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when your controlled target is broken is turned OFF!") 
	end	
end

function AudioAnnounceCrowdBreaks_OnClick()
	if AudioAnnounceCrowdBreaks:GetChecked() then AfterlifeAddonSettings[8] = true else AfterlifeAddonSettings[8] = false end
	if AfterlifeAddonSettings[8] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when your controlled target gets broken is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when your controlled target gets broken is now switched OFF!") 
	end
end

--
--	Chat/Audio Announce Misses
--
function ChatAnnounceSpellMisses_OnClick()
	if ChatAnnounceSpellMisses:GetChecked() then AfterlifeAddonSettings[9] = true else AfterlifeAddonSettings[9] = false end
	if AfterlifeAddonSettings[9] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when a spell you cast misses is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when a spell you cast misses is turned OFF!") 
	end	
end

function AudioAnnounceSpellMisses_OnClick()
	if AudioAnnounceSpellMisses:GetChecked() then AfterlifeAddonSettings[10] = true else AfterlifeAddonSettings[10] = false end
	if AfterlifeAddonSettings[10] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a spell you cast misses is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a spell you cast misses is now switched OFF!") 
	end
end

--
-- Chat/Audio Announce Spell Failures
--
function ChatAnnounceSpellFailure_OnClick()
	if ChatAnnounceSpellFailure:GetChecked() then AfterlifeAddonSettings[11] = true else AfterlifeAddonSettings[11] = false end
	if AfterlifeAddonSettings[11] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when a spell you cast fails is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when a spell you cast fails is turned OFF!") 
	end	
end

function AudioAnnounceSpellFailure_OnClick()
	if AudioAnnounceSpellFailure:GetChecked() then AfterlifeAddonSettings[12] = true else AfterlifeAddonSettings[12] = false end
	if AfterlifeAddonSettings[12] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a spell you cast fails is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a spell you cast fails is now switched OFF!") 
	end
end

--
--	Chat/Audio Announce Interrupts
--
function ChatAnnounceInterrupts_OnClick()
	if ChatAnnounceInterrupts:GetChecked() then AfterlifeAddonSettings[13] = true else AfterlifeAddonSettings[13] = false end
	if AfterlifeAddonSettings[13] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when you interrupt a spell is turned ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Chat announce when you interrupt a spell is turned OFF!") 
	end	
end

function AudioAnnounceInterrupts_OnClick()
	if AudioAnnounceInterrupts:GetChecked() then AfterlifeAddonSettings[14] = true else AfterlifeAddonSettings[14] = false end
	if AfterlifeAddonSettings[14] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a I interrupt a spell is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play sound when a I interrupt a spell is now switched OFF!") 
	end
end

--
--	Ignore if I break my own target
--
function IgnorePersonalBreaks_OnClick()
	if IgnorePersonalBreaks:GetChecked() then AfterlifeAddonSettings[15] = true else AfterlifeAddonSettings[15] = false end
	if AfterlifeAddonSettings[15] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You are now ignoring your own breaks (no announces to chat or audio).") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You will announce your own breaks and play audio based on your settings.") 
	end	
end

--
--	Announce in Battlegrounds
--
function AnnounceInBG_OnClick()
	if AnnounceInBG:GetChecked() then AfterlifeAddonSettings[42] = true else AfterlifeAddonSettings[42] = false end
	if AfterlifeAddonSettings[42] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You will announce / play audio in battlegrounds based on your settings.") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 You will not announce any crowd controls in the battlegrounds.") 
	end	
end

--
--	Display Aieee popup
--
function DisplayBatmanPopup_OnClick()
	if DisplayBatmanPopup:GetChecked() then AfterlifeAddonSettings[21] = true else AfterlifeAddonSettings[21] = false end
	if AfterlifeAddonSettings[21] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Display a batman style Aieee popup when your target breaks is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Display a batman style Aieee popup when your target breaks is now switched OFF!") 
	end	
end


--
--	Chat Announce Tank Abilities
--
function ChatAnnounceTankAbilities_OnClick()
	if ChatAnnounceTankAbilities:GetChecked() then AfterlifeAddonSettings[49] = true else AfterlifeAddonSettings[49] = false end
	if AfterlifeAddonSettings[49] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Announce important tank abilities such as taunt is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Announce important tank abilities such as taunt is now switched OFF!") 
	end			
end


--
--	Random Taunt Sound
--
function AudioAnnounceTaunt_OnClick()
	if AudioAnnounceTaunt:GetChecked() then AfterlifeAddonSettings[50] = true else AfterlifeAddonSettings[50] = false end
	if AfterlifeAddonSettings[50] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play a random funny taunt sound when you taunt is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Play a random funny taunt sound when you taunt is now switched OFF!") 
	end				
end


--
--	Audio Announce Raid Markers on others CC breaks
--

function AfterlifeAnnounceRaidMarkers_OnClick()
	if AfterlifeAnnounceRaidMarkers:GetChecked() then AfterlifeAddonSettings[52] = true else AfterlifeAddonSettings[52] = false end
	if AfterlifeAddonSettings[52] then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Audio announce raid markers of raid crowd controlled mobs that break is now switched ON!") 
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control|cffFFFF00 Audio announce raid markers of raid crowd controlled mobs that break is now switched OFF!") 
	end		
	
end


----------------------------------------- BAR ADJUSTMENT ----------------------------------------------


--
--	Bar Height
--
function BarSliderHeight_OnValueChanged()
	local value = math.floor(BarSliderHeight:GetValue())
	AfterlifeHeightText:SetText(value)	
	AfterlifeAddonSettings[25] = value
	AfterlifeAddonSettings[34] = value
	AfterlifePrimaryGroup:SetHeight(AfterlifeAddonSettings[25])
	AfterlifeDiminishGroup:SetHeight(AfterlifeAddonSettings[34])
end

--
-- Bar Width
--
function BarSliderWidth_OnValueChanged()
	local value = math.floor(BarSliderWidth:GetValue())
	AfterlifeWidthText:SetText(value)	
	AfterlifeAddonSettings[26] = value
	AfterlifeAddonSettings[35] = value
	AfterlifePrimaryGroup:SetWidth(AfterlifeAddonSettings[26])
	AfterlifeDiminishGroup:SetWidth(AfterlifeAddonSettings[35])
end

--
--	Bar Font
--
function BarSliderFont_OnValueChanged()
	local value = math.floor(BarSliderFont:GetValue())
	AfterlifeFontSizeText:SetText(value)	
	AfterlifeAddonSettings[30] = value
	AfterlifeAddonSettings[39] = value
	AfterlifePrimaryGroup:SetGroupFontSize(AfterlifeAddonSettings[30])
	AfterlifeDiminishGroup:SetGroupFontSize(AfterlifeAddonSettings[39])
end

--
--	Bar Texture
--
function BarSliderTexture_OnValueChanged()
	local value = math.floor(BarSliderTexture:GetValue())
	AfterlifeAddonSettings[27] = value
	AfterlifeAddonSettings[36] = value
	AfterlifeGroupTexture:SetTexture(AfterlifeTextures[value])
	AfterlifePrimaryGroup:SetTexture(AfterlifeTextures[AfterlifeAddonSettings[27]])
	AfterlifeDiminishGroup:SetTexture(AfterlifeTextures[AfterlifeAddonSettings[36]])
end
